
; ATmega16

; 20.01.2009 M'Soft Berlin

.equ	VER		= '0'
.equ	REV		= '1'

.include "m32def.inc"

.include "Definitionen.inc"

;****************************** Verktor-Liste ************************

.CSEG
       rjmp    Reset
	 
;****************************** Programm-Beginn **********************

;*********************************************************************
;  Initialisierungsroutine
;*********************************************************************

.ORG	INT_VECTORS_SIZE

; Hardware initialisieren

Reset:
		ldi     TEMP_0,low(RAMEND)          ; Stack an das interne Ram-Ende
        out     SPL,TEMP_0
		ldi     TEMP_0,high(RAMEND)
        out     SPH,TEMP_0

; Port A *************************************************************

		ser		TEMP_0							; PullUp ein			
        out     PORTA,TEMP_0               	
		clr		TEMP_0							; Eingang Adressen L			
		out     DDRA,TEMP_0

; Port B *************************************************************
			
		ser		TEMP_0							; PullUp ein			
        out     PORTB,TEMP_0               	
		clr		TEMP_0							; Eingang Daten			
		out     DDRB,TEMP_0

; Port C *************************************************************

		ser		TEMP_0							; PullUp ein			
        out     PORTC,TEMP_0               	
		clr		TEMP_0							; Eingang Adressen H			
		out     DDRC,TEMP_0

; Port D *************************************************************

		ser		TEMP_0							; PullUp ein			
        out     PORTD,TEMP_0               	
		clr		TEMP_0							; Eingang Control			
		out     DDRD,TEMP_0

; UART ***************************************************************

        ldi     TEMP_0,high(UART_BAUD_SELECT)
        out     UBRRH,TEMP_0
        ldi     TEMP_0,low(UART_BAUD_SELECT)
        out     UBRRL,TEMP_0
        ldi     TEMP_0,(1<<TXEN) | (1<<RXEN)
        out     UCSRB,TEMP_0
        ldi     TEMP_0,(1<<URSEL)+(1<<UCSZ1)+(1<<UCSZ0)
        out     UCSRC,TEMP_0

;*********************************************************************				 

; Software initialisieren
		clr		FLAGS
		clr		NULL
											 
;*********************************************************************
;  Main-Loop
;*********************************************************************

main:	
		load_p	Z,text_reset
		rcall	uart_send_rom_text
		rcall	uart_send_newline

main_loop:
		rcall	uart_send_newline
		ldi		TEMP_0,'>'
		rcall	uart_send_byte

		rcall	uart_receive_string

		sbrs	FLAGS,FLAG_STR_OK
		rjmp	main_no_ok

		rcall	parse_string
		sbrc	FLAGS,FLAG_CMD_ERR
		rjmp	main_cmd_err

		sbrc	FLAGS,FLAG_PAR_ERR
		rjmp	main_par_err

		rjmp	main_end

main_no_ok:
		sbrs	FLAGS,FLAG_STR_LEN
		rjmp	main_no_len

		rcall	uart_send_newline
		load_p	Z,text_string_len
		rjmp	main_end_err

main_no_len:
		load_p	Z,text_string_err
		rjmp	main_end_err

main_cmd_err:
		load_p	Z,text_cmd_err
		rjmp	main_end_err

main_par_err:
		load_p	Z,text_par_err

main_end_err:
		rcall	uart_send_rom_text
		rcall	uart_send_newline

main_end:
		clr		FLAGS
		rjmp	main_loop


;*********************************************************************				 

.include "Subroutinen.inc"
.include "UART.inc"
.include "Tabellen.inc"

